//
//  AgeViewController.m
//  Age
//
//  Created by aka on 08/12/22.
//  Copyright __MyCompanyName__ 2008. All rights reserved.
//

#import "AgeViewController.h"

@implementation AgeViewController

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
// ビューの読み込みが完了した時に呼び出されるメソッド
- (void)viewDidLoad
{
	// スーパー・クラスのメソッドを呼び出す
    [super viewDidLoad];
	
	// デイト・ピッカーを今日の日付に設定
	birthdayPicker.date = [NSDate date];
	// 年齢を計算
	[self calc];
}


// デイト・ピッカーやセグメンティッド・コントロールの値が変化すると呼び出される
- (IBAction)calc
{
	// 年齢計算
	// デイト・ピッカーから誕生日を取得
	NSDate *birthday = birthdayPicker.date;
	// 今日の日付を取得
	NSDate *today = [NSDate date];
	
	// グレゴリオ暦のカレンダーを作成
	NSCalendar *gregorian = [[NSCalendar alloc]
							 initWithCalendarIdentifier:NSGregorianCalendar];
	
	// 期間の単位の設定
	NSUInteger	unitFlags;
	switch (unitControl.selectedSegmentIndex)
	{
		case 0:	// 年単位
			unitFlags = NSYearCalendarUnit;
			break;
			
		case 1:	// 月単位
			unitFlags = NSMonthCalendarUnit;
			break;
			
		case 2:	// 日単位
			unitFlags = NSDayCalendarUnit;
			break;
	}
	
	// 誕生日から今日までの期間を求める
	NSDateComponents *components = [gregorian components:unitFlags	// 期間の単位
												fromDate:birthday	// 起点の日付
												  toDate:today		// 終点の日付
												 options:0];		// オプション
	// 期間から年齢を得る
	NSInteger age;
	switch (unitFlags)
	{
		case NSYearCalendarUnit:	// 年単位
			age = [components year];
			break;
			
		case NSMonthCalendarUnit:	// 月単位
			age = [components month];
			break;
			
		case NSDayCalendarUnit:		// 日単位
			age = [components day];
			break;
	}
	
	// 年齢を結果表示ラベルに表示
	resultLabel.text = [NSString stringWithFormat:@"%d", age];
	
	// カレンダーを解放
	[gregorian release];
	
	// 表示単位によって年齢ラベルの表示を変更
	switch (unitFlags)
	{
		case NSYearCalendarUnit:	// 年単位
			ageLabel.text = NSLocalizedString(@"Age in Years", @"");
			break;
			
		case NSMonthCalendarUnit:	// 月単位
			ageLabel.text = NSLocalizedString(@"Age in Months", @"");
			break;
			
		case NSDayCalendarUnit:		// 日単位
			ageLabel.text = NSLocalizedString(@"Age in Days", @"");
			break;
	}
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/


- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc
{
    [super dealloc];
}

@end
